﻿--------------------------------------------------------------------------------
-- GetLink Revision 3, bugfix/patch 11
--------------------------------------------------------------------------------
-- vars --
GLVersion = 3.11;
-- slash cmds --
GLSlashCmd = function(search)
	local links, num = GetLink(search);    
    if (not links) then
        GLPrint(string.format(GETLINK_NO_RESULTS, search));
        return;
    end
    local t = '';
	if (num ~= 1) then t = 's'; end
	for i = 1, num do GLPrint(links[i]) end
    GLPrint(string.format(GETLINK_REG_RESULTS, num, search))
	return
end
SlashCmdList["GETLINK"] = GLSlashCmd;
SLASH_GETLINK1 = "/getlink";
SLASH_GETLINK1 = "/gl";
-- k --
function GLPrint(foo) DEFAULT_CHAT_FRAME:AddMessage(foo, .7, .9, 1); end
function GetLink(options_t)
    local search, options, results = {}, {}, {};
	options.name = "";
	string.gsub(options_t, "(%S+)", function(s) table.insert(search, s); end);
	for k,v in next,search do
		local _,_,opt,val = string.find(v, "(.+)=(.+)");
		if((not opt) or (not val)) then
			options.name = options.name .. " " .. v;
		else
			options[string.lower(opt)] =  string.lower(val);
		end
	end
	options.name = string.gsub(options.name, "^%s*(.+)$", string.lower)
	for i = 1, 25000 do
		local name,_,quality,_,level,item_type,sub_type,_,armor_slot = GetItemInfo(i);
		if(name) then
			local isBadRes = nil;
			for opt, val in next,options do
				if(opt == "name") then
                    local lname = string.lower(name);
					if(not string.find(lname, val)) then
                        -- new implementation : acronyms
                        local tmp = '';
                        string.gsub(lname, "(%S+)", function(s) tmp = tmp .. string.sub(s, 1, 1) end);
                        if(tmp ~= val) then isBadRes = 1; break; end
                    end
				elseif(opt == "quality") then
					if(type(tonumber(val)) == "number") then
						if(tonumber(val) ~= quality) then isBadRes = 1; break; end
					else
						if(GLWords.qualities[val]) then
							if(GLWords.qualities[val] ~= quality) then
								isBadRes = 1; break;
							end
						else	isBadRes = 1; break;
						end
					end
				elseif(opt == "level") then
					local _,_,lvl,mod = string.find(val, "(%d%d?)(.)$");
					if(mod == "+") then
						lvl = tonumber(lvl);
						if(level < lvl) then isBadRes = 1; break; end
					elseif(mod == "-") then 
						lvl = tonumber(lvl);
						if(level > lvl) then isBadRes = 1; break; end
					else
						val = tonumber(val);
						if(type(val) == "number") then
							if(level ~= tonumber(val)) then isBadRes = 1; break; end
						end
					end
				elseif(opt == "item_type") then
				elseif(opt == "sub_type") then
				elseif(opt == "armor_slot") then
				end
			end
			if(not isBadRes) then
				table.insert(results, ITEM_QUALITY_COLORS[quality].hex ..
									"|Hitem:" .. i .. ":0:0:0|h[" .. name .. "]|h|r");
			end
		end
	end
	return results, #results
end
